/*
    stopa:  0..n-1, zobrazuje se +1 jako fdisk!, 1..n
    hlava:  0..n-1
    sektor: 1..n

*/
#include <stdio.h>
#include <string.h>

#ifdef linux
#include <errno.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/hdreg.h>
#include <linux/genhd.h>
#include <unistd.h>

#if defined(__GNUC__) || defined(HAS_LONG_LONG)
typedef long long ext2_loff_t;
#else
typedef long      ext2_loff_t;
#endif

#endif /* linux */

extern ext2_loff_t ext2_llseek(unsigned int fd,
                               ext2_loff_t offset,
                               unsigned int origin);


int maxcyl=0,maxhead=0,maxsec=0,disks=0;
char buf[32768];
char beginstr[100];

typedef struct polozka{
  unsigned char boot,bhead;
  unsigned short int bxcyl;
  unsigned char sys,ehead;
  unsigned short int excyl;
  unsigned long int begin,size;
}POLOZKA;

typedef struct tpol{
  int n;
  char s[16];
}TPOL;
TPOL pols[]=
     {{0,"nothing"},
     {0x1,"FAT12"},
     {0x2,"XENIX root"},
     {0x3,"XENIX usr"},
     {0x4,"FAT16 <32M"},
     {0x5,"Extended"},
     {0x6,"FAT16 (BIGDOS)"},
     {0x7,"HPFS/NTFS"},
     {0x8,"AIX (split)"},
     {0x9,"AIX bootable"},
     {0xa,"OS/2 Boot Manag"},
     {0xb,"FAT32"},
     {0xc,"FAT32 LBA"},
     {0xe,"FAT16 LBA"},
     {0xf,"W95 Ext. LBA"},
     {0x10,"OPUS"},
     {0x11,"Hidden FAT12"},
     {0x12,"Compaq diagnost"},
     {0x14,"Hidden FAT16<32"},
     {0x16,"Hidden FAT16"},
     {0x17,"Hidd. HPFS/NTFS"},
     {0x18,"AST Win swap"},
     {0x24,"NEC DOS"},
     {0x3c,"PartitionMagic"},
     {0x40,"Venix 80286"},
     {0x41,"PPC PReP Boot"},
     {0x42,"SFS"},
     {0x4d,"QNX4.x"},
     {0x4e,"QNX4.x 2nd part"},
     {0x4f,"QNX4.x 3rd part"},
     {0x50,"OnTrack DM"},
     {0x51,"OnTrack DM6 Aux"},
     {0x52,"CP/M"},
     {0x53,"OnTrack DM6 Aux"},
     {0x54,"OnTrackDM6"},
     {0x55,"EZ-Drive"},
     {0x56,"Golden Bow"},
     {0x5c,"Priam Edisk"},
     {0x61,"SpeedStor"},
     {0x63,"GNU HURD or Sys"},
     {0x64,"Novell Netware"},
     {0x65,"Novell Netware"},
     {0x70,"DiskSecure Mult"},
     {0x75,"PC/IX"},
     {0x80,"Old Minix"},
     {0x81,"Minix"},
     {0x82,"Linux swap"},
     {0x83,"ext2"},
     {0x84,"OS/2 hidden C:"},
     {0x85,"Linux extended"},
     {0x86,"NTFS volume set"},
     {0x87,"NTFS volume set"},
     {0x93,"Amoeba"},
     {0x94,"Amoeba BBT"},
     {0xa0,"IBM Thinkpad hi"},
     {0xa5,"BSD/386"},
     {0xa6,"OpenBSD"},
     {0xa7,"NeXTSTEP"},
     {0xb7,"BSDI fs"},
     {0xb8,"BSDI swap"},
     {0xc1,"DRDOS/sec"},
     {0xc4,"DRDOS/sec"},
     {0xc6,"DRDOS/sec"},
     {0xc7,"Syrinx"},
     {0xdb,"CP/M (CTOS)"},
     {0xe1,"DOS access"},
     {0xe3,"DOS R/O"},
     {0xe4,"SpeedStor"},
     {0xeb,"BeOS fs"},
     {0xf1,"SpeedStor"},
     {0xf4,"SpeedStor"},
     {0xf2,"DOS secondary"},
     {0xfe,"LANstep"},
     {0xff,"BBT"},
     {-1,"unknown"}};


char *gettype(int typ){
  int i;

  for (i=0;pols[i].n>=0;i++)
    if (pols[i].n==typ) break;
  return(pols[i].s);
}

int getinfo(char *dev,int *maxcyl,int *maxhead,int *maxsec,int *disks){
#ifdef linux
  int fd;
  struct hd_geometry geometry;
  
  if ((fd=open(dev,O_RDONLY))<0) {
    printf(" can't open(%s) \n",dev);
    return(-1);
  }    
  if (ioctl(fd, HDIO_GETGEO, &geometry)<0) {
    printf(" can't ioctl(%s) \n",dev);
    return(-1);
  }
  *maxcyl=geometry.cylinders;
  *maxhead=geometry.heads;
  *maxsec=geometry.sectors;
  *disks=1;
  return(fd);

#else
  union REGS rg;
  struct SREGS sr;

  rg.h.ah=8;
  rg.h.dl=drive;
  int86x(0x13,&rg,&rg,&sr);
  if (rg.x.cflag) {
    printf("getinfo(0x%x,...) = 0x%x \n",drive,rg.h.ah);
    return(rg.h.ah);
  }

  *maxhead=rg.h.dh;
  *maxcyl=rg.h.ch|((rg.h.cl<<2)&0x300);
  *maxsec=rg.h.cl&0x3f;
  *disks=rg.h.dl;
  return(0);
#endif  
}

int readsec(int fd,int cyl,int head,int sec,char *buf){
#ifdef linux
  ext2_loff_t i;

  i=(ext2_loff_t) 512*(((ext2_loff_t) sec-1)+
    (ext2_loff_t) head*(ext2_loff_t) maxsec+
    (ext2_loff_t) cyl*(ext2_loff_t) maxhead*(ext2_loff_t) maxsec);

  if ((i=ext2_llseek(fd,i,SEEK_SET))<0) {
    printf(" can't lseek(%d,%ld)  \n",fd,(long int)i);
    printf("   -------- %d/%d/%d == %lld, errno=%d, %s \n",cyl,head,sec,i,errno,strerror(errno));
    return(1);
  }
  read(fd,buf,512);
  return(0);
    
#else
  union REGS rg;
  struct SREGS sr;

  rg.h.ah=2;
  rg.h.al=maxsec;
  rg.h.dh=head;
  rg.h.dl=drive;
  rg.h.ch=cyl&0xff;
  rg.h.cl=((cyl&0x300)>>2)|(sec&0x3f);
  rg.x.bx=FP_OFF(buf);
  sr.es=FP_SEG(buf);
  int86x(0x13,&rg,&rg,&sr);
  if (rg.x.cflag) {
    printf("readsec(0x%x,%d,%d,%d,%p) = 0x%x \n",drive,cyl,head,sec,buf,rg.h.ah);
    return(rg.h.ah);
  }
  return(0);
  #endif
}


int trace(int fd,int cyl,int head,int sec,ext2_loff_t o){
  char backstr[100];
  int i,bc,bs,ec,es;
  POLOZKA *p,bb[4];

  strcpy(backstr,beginstr);
  strcat(beginstr,"|");
  printf("%s+-%4d/%3d/%2d: \n",backstr,cyl+1,head,sec);
  if ((i=readsec(fd,cyl,head,sec,buf))!=0) return(i);
  memcpy((void *)bb,(void *)&buf[0x1be],4*sizeof(POLOZKA));
  p=bb;
  for (i=0;i<4;i++,p++){
    if (p->sys==0) continue;
    bc=((p->bxcyl>>8)&0xff)|((p->bxcyl<<2)&0x300);
    bs=p->bxcyl&0x3f;
    ec=((p->excyl>>8)&0xff)|((p->excyl<<2)&0x300);
    es=p->excyl&0x3f;
    printf("%-8s %-15s%s %4d/%3d/%2d-%4d/%3d/%2d %9llu %9lu %luM\n",
           beginstr,gettype(p->sys),p->boot?"B":" ",
           bc+1,p->bhead,bs,
           ec+1,p->ehead,es,
           p->begin+o,p->size,p->size/2048);
    if (p->sys==5 || p->sys==0x0f || p->sys==0x85) trace(fd,bc,p->bhead,bs,p->begin+o);
  }
  printf("%s+-\n",backstr);
  strcpy(beginstr,backstr);
  return(0);
}

int search(int fd,int thorough){
  int cyl,head,*p_i,mhead;
  unsigned short int *p_us;
  unsigned char *p_c;

  if (thorough) mhead=maxhead;
  else mhead=2;

  for (cyl=0;cyl<maxcyl;cyl++){
    printf("\r                 \r %d/%d ",cyl,maxcyl);
    for (head=0;head<mhead;head++){ /* empirical: partition begins on head 0 or 1 */
      /* x86 bootsector or MBR loader or LILO in ext2 or ... */
      readsec(fd,cyl,head,1,buf);
      p_us=(unsigned short int *)(buf+510);
      if (*p_us==0xaa55){
        printf("\r found 0xaa55 flag on CHS: %d/%d/%d \n",cyl+1,head,1);
      }

      /* fat */
      p_c=(unsigned char *)buf;
      p_i=(unsigned int *)(buf+0x36);
      if (p_c[0]==0xeb && p_c[2]==0x90 && (*p_i&0xffffff)==0x544146){
        printf("\r found FAT flag on CHS: %d/%d/%d \n",cyl+1,head,1);
      }

      /* ext2 */
      readsec(fd,cyl,head,3,buf);
      p_us=(unsigned short int *)(buf+0x38);
      if (*p_us==0xef53){
        printf("\r found ext2 flag on CHS: %d/%d/%d \n",cyl+1,head,1);
      }

      /* linux swap */
      readsec(fd,cyl,head,8,buf);
      p_us=(unsigned short int *)(buf+0x1f6);
      p_i=(int *)(buf+0x1f8);
      if (*p_us==0x5753 && *p_i==0x532d5041 && p_i[1]==0x45434150){
        printf("\r found swap flag on CHS: %d/%d/%d \n",cyl+1,head,1);
      }


    }

    fflush(stdout);
  }
  return(0);
}

void usage(void){
  printf(" usage: hd [-s|-t] device \n");
  printf("        lists partitions on device \n");
  printf("        -s search known partitions \n");
  printf("        -t thorough search (slower) \n");
  printf("\n");
}


int main(int argc,char *argv[]){
  int i,fd,c,scan=0;

  while ((c=getopt(argc,argv,"st"))!=EOF) {
    switch(c){
      case 's':
        scan=1;
      break;
      case 't':
        scan=2;
      break;
      default:
        usage();
        return(0);
      break;
    }
  }

  for (i=1;i<argc;i++){
    if (argv[i][0]!='-') break;
  }

  if (i==argc) {
    usage();
    return(1);
  }

  if ((fd=getinfo(argv[i],&maxcyl,&maxhead,&maxsec,&disks))<0){
    printf(" can't read disk geometry \n");
    return(1);
  }

  if (scan){
    search(fd,scan>1?1:0);
    close(fd);
    return(0);
  }

  printf("%s  c:%d  h:%d  s:%d   disks:%d \n",argv[1],maxcyl,maxhead,maxsec,disks);
  printf("        CHS      type boot  begin CHS-end CHS    begin[sec]  end[sec] size[MB]\n");
  strcpy(beginstr,"");
  if ((i=trace(fd,0,0,1,0))!=0){
    printf(" doslo k chybe pri trace 0x%x \n",i);
    return(1);
  }


  close(fd);
  return(0);
}


