#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>


int main(int argc,char *argv[]){
  int ip,i;
  struct hostent *he;
  struct in_addr ia;
  struct in_addr ins;

  char **c,s[300];

  if (argc<2) {
    fprintf(stderr," usage: nslookdown hostname \n");
    return(1);
  }

  if (inet_aton(argv[1],&ia)!=0) { /* argv[1] is ip */
    if ((he=gethostbyaddr((void *)&(ia.s_addr),sizeof(ia.s_addr),AF_INET))==NULL){
      fprintf(stderr,"gethostbyaddr() failed\n");
      return(2);
    }
  }
  else{
    if ((he=gethostbyname(argv[1]))==NULL){
      fprintf(stderr,"gethostbyname() failed\n");
      return(2);
    }
  }
  printf(" HOSTNAME='%s'\n",he->h_name);

  c=he->h_aliases;
  i=1;
  while (*c!=NULL) {
    printf(" ALIAS_%d='%s'\n",i,*c);
    c++;
    i++;
  }

  c=he->h_addr_list;
  i=1;
  while (*c!=NULL) {
    memcpy(&ins.s_addr,*c,4);
    printf(" IP_%d='%s'\n",i,inet_ntoa(ins));
    c++;
    i++;
  }

/* - Function: char * inet_ntoa (struct in_addr ADDR)
     This function converts the IPv4 Internet host address ADDR to a
     string in the standard numbers-and-dots notation.  The return
     value is a pointer into a statically-allocated buffer.  Subsequent
     calls will overwrite the same buffer, so you should copy the
     string if you need to save it.
  */


  return(0);

}
